var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
define("src/temporaryStorage", ["require", "exports"], function (require, exports) {
    "use strict";
    var TemporaryStorage = (function () {
        function TemporaryStorage() {
            this.tempStorage = {};
        }
        TemporaryStorage.prototype.setTempStorage = function (key, value) {
            key = key.toLowerCase();
            if (this.tempStorage) {
                this.tempStorage[key] = value;
            }
        };
        ;
        TemporaryStorage.prototype.getTempStorage = function (key) {
            key = key.toLowerCase();
            if (this.tempStorage && key in this.tempStorage) {
                return this.tempStorage[key];
            }
            ;
            return null;
        };
        ;
        return TemporaryStorage;
    }());
    exports.__esModule = true;
    exports["default"] = TemporaryStorage;
});
define("src/shellApp", ["require", "exports", "src/temporaryStorage"], function (require, exports, temporaryStorage_1) {
    "use strict";
    var ShellApp = (function () {
        function ShellApp() {
            this.isDevMode = !!window.localStorage.getItem("dev-mode");
            this.isDisableSsl = !!window.localStorage.getItem("dev-mode-disable-ssl");
            this.htmlPage = "";
            this.defaultServer = "";
            this.targetServer = window.localStorage.getItem("last-server") || this.defaultServer;
            this.scheme = !this.isDevMode ? "https://" : "http://";
            this.body = document.getElementsByTagName("body")[0];
            this.frame = document.createElement("iframe");
            this.shellDom = document.getElementById("shell");
            this.loadingDom = document.getElementById("loading");
            this.retryButton = document.getElementById("retryButton");
            this.retryFailed = document.getElementById("retryFailed");
            this.errorMessage = document.getElementById("errorMessage");
            this.failedToConnectText = document.getElementById("failedToConnect");
            this.loadingText = document.getElementById("loadingText");
            this.mainBody = document.getElementById("main");
            this.retryCount = 0;
            this.languageIndex = 0;
            this.retryText = "";
            this.statusWord = "";
            this.firstLoad = true;
            this.whitelabel = null;
            this.startupBatteryEventData = null;
            this.documentEvents = {
                "backbutton": this.defaultDocumentEventListener,
                "pause": this.defaultDocumentEventListener,
                "resume": this.defaultDocumentEventListener,
                "online": this.defaultDocumentEventListener,
                "offline": this.defaultDocumentEventListener
            };
            this.windowEvents = {
                "batterystatus": this.defaultWindowEventListener
            };
            this.tempStorage = new temporaryStorage_1["default"]();
            this.strings = [
                ["Loading...", "Chargement en cours ...", "Cargando ...", "読み込んでいます...", "Wird geladen ... ", "Ładowanie..."],
                ["Please try again to continue.", "Veuillez réessayer pour continuer.", "Trate de nuevo para proseguir.", "再度お試しください。", "Versuchen Sie es erneut, um fortzufahren.", "Spróbuj ponownie."],
                ["No Network Connection", "Pas de connexion au réseau", "No hay conexión de red", "ネットワークは接続されていません", "Keine Netzwerkverbindung", "Brak połączenia z Internetem"],
                ["Failed to reach the server {0} times in a row.", "Pas réussi à atteindre le serveur {0} fois de suite.", "No se pudo alcanzar el servidor {0} veces en una fila.", "列の中のサーバー{0} 回に達しませんでした。", "Konnte den Server {0} mal in Folge nicht erreichen.", "Niepowodzenie połączenia z serwerem {0} razy z rzędu."],
                ["Status", "Statut", "Estado", "ステータス", "Status", "Status"]
            ];
        }
        ShellApp.prototype.getTargetUrl = function () {
            return this.scheme + this.getServerUrl(this.targetServer) + this.htmlPage;
        };
        ShellApp.prototype.getServerUrl = function (server) {
            // Strip server of http(s):// and trailing slashes
            return server.replace(/\S*:\/\//, "").replace(/\/$/, "").toLowerCase();
        };
        ShellApp.prototype.resetTargetServer = function () {
            this.targetServer = window.localStorage.getItem("last-server") || this.defaultServer;
        };
        ShellApp.prototype.initialize = function () {
            var _this = this;
            window.addEventListener("message", this.receiveMessage.bind(this), false);
            document.addEventListener('deviceready', this.onDeviceReady.bind(this), false);
            this.retryButton.addEventListener("click", function () { _this.checkUrl(_this.getTargetUrl(), _this.frameStartup, true); }, false);
            window.Raygun.withTags(["shell"]);
            window.Raygun.setVersion();
            window.Raygun.init("e3i1VlE2+Sbq7mb3i7CImw==", {
                ignoreAjaxAbort: false,
                ignore3rdPartyErrors: false
            }).attach();
            window.handleOpenURL = function (url) {
                // Global function required to be present (from the cordova-plugin-customurlscheme plugin)
                // Sets the url in the shell, which is accessible from the iframe as a global (getPassedInUrl)
                console.log("SHELL STARTUP passedURL" + ": " + url);
                _this.tempStorage.setTempStorage("passedUrl", url);
            };
        };
        ShellApp.prototype.checkUrl = function (url, callback, isRetry) {
            var http = new XMLHttpRequest(), shell = this;
            http.open("GET", url);
            http.timeout = (url.toLowerCase().indexOf(this.defaultServer) !== -1) ? 100000 : 30000;
            http.onreadystatechange = function () {
                if (this.readyState === this.DONE) {
                    callback.bind(shell)(this.status, isRetry, this);
                }
            };
            if (!isRetry) {
                this.loadingDom.style.display = "block";
            }
            http.send();
        };
        ShellApp.prototype.onDeviceReady = function () {
            this.mainBody.style.display = "none";
            this.getLanguage();
            // Required for iOS, even though in the config.xml
            window.StatusBar.overlaysWebView(false);
            if (this.isDevMode) {
                this.targetServer = prompt("Enter server IP", this.targetServer);
            }
            this.checkUrl(this.scheme + this.getServerUrl(this.targetServer) + "/APIV1/GetVersion", this.frameStartup);
        };
        // Can be overriden
        ShellApp.prototype.receiveMessage = function (event) {
            switch (event.data.type) {
                case "drive:settempstorage":
                    this.tempStorage.setTempStorage(event.data.key, event.data.value);
                    break;
            }
        };
        ShellApp.prototype.defaultDocumentEventListener = function (dataObj) {
            console.log("SHELL " + dataObj.type + ": " + JSON.stringify(dataObj));
            this.frame.contentDocument.dispatchEvent(new CustomEvent(dataObj.type, { detail: dataObj }));
        };
        ShellApp.prototype.defaultWindowEventListener = function (dataObj) {
            // The first time we receive a battery event, save it and wait for Drive iframe to finish loading
            // before sending it again
            if (dataObj.type === "batterystatus" && !this.startupBatteryEventData) {
                this.startupBatteryEventData = dataObj;
            }
            console.log("SHELL " + dataObj.type + ": " + JSON.stringify(dataObj));
            this.frame.contentWindow.dispatchEvent(new CustomEvent(dataObj.type, { detail: dataObj }));
        };
        ShellApp.prototype.frameStartup = function (httpCode, isRetry, xhr) {
            var _this = this;
            var loadImpl = function () {
                _this.frame.id = "geotabFrame";
                _this.frame.src = _this.getTargetUrl();
                _this.frame.style.display = "none";
                _this.frame.onload = _this.frameOnload.bind(_this);
                // Pass Cordova document events over to the frame
                for (var eventName in _this.documentEvents) {
                    document.addEventListener(eventName, _this.documentEvents[eventName].bind(_this));
                }
                // Pass Cordova window events over to the frame
                for (var eventName in _this.windowEvents) {
                    window.addEventListener(eventName, _this.windowEvents[eventName].bind(_this));
                }
                _this.shellDom.style.display = "none";
                _this.body.style.margin = "0";
                _this.body.appendChild(_this.frame);
            };
            switch (httpCode) {
                case 200:
                case 201:
                case 204:
                case 304:
                    loadImpl();
                    break;
                default:
                    var lastServer = window.localStorage.getItem("last-server");
                    if (lastServer) {
                        if (httpCode === 0) {
                            // Tablet network issue, but we've already signed in against the "last-server".
                            // so navigate there directly if we have localstorage for it
                            loadImpl();
                        }
                        else {
                            // Not a tablet issue, the server appears to be missing/offline/broken
                            // Retry against the login default server
                            this.checkUrl(this.scheme + this.getServerUrl(this.defaultServer) + this.htmlPage, this.frameStartup);
                        }
                        return;
                    }
                    this.displayError(httpCode, isRetry);
                    this.loadingDom.style.display = "none";
                    var message = "Loading error: " +
                        (xhr.statusText || "") + " " +
                        (xhr.responseType || "") + " " +
                        (this.getTargetUrl() || "");
                    window.Raygun.send(new Error("Shell: Failed to load Drive (status " + httpCode + ")"), {
                        status: xhr.status,
                        statusText: xhr.statusText,
                        message: message,
                        url: this.getTargetUrl(),
                        contentType: xhr.responseType,
                        responseData: xhr.responseText
                    });
                    break;
            }
        };
        ShellApp.prototype.displayError = function (httpCode, isRetry) {
            var _this = this;
            this.errorMessage.textContent = this.statusWord + " " + httpCode;
            this.shellDom.style.display = "block";
            if (isRetry) {
                this.retryCount += 1;
                this.retryFailed.textContent = this.retryText.replace(/\{0\}/i, this.retryCount.toString());
                this.retryFailed.style.display = "block";
                setTimeout(function () {
                    _this.retryFailed.style.display = "none";
                }, 2000);
            }
        };
        ShellApp.prototype.getLanguage = function () {
            var _this = this;
            var userLanguage;
            navigator.globalization.getPreferredLanguage(function (language) {
                userLanguage = language.value;
                if (userLanguage.match(/^fr/i)) {
                    _this.languageIndex = 1;
                }
                else if (userLanguage.match(/^es/i)) {
                    _this.languageIndex = 2;
                }
                else if (userLanguage.match(/^ja/i)) {
                    _this.languageIndex = 3;
                }
                else if (userLanguage.match(/^de/i)) {
                    _this.languageIndex = 4;
                }
                else if (userLanguage.match(/^pl/i)) {
                    _this.languageIndex = 5;
                }
                else {
                    _this.languageIndex = 0;
                }
                _this.translateStrings();
            }, function () {
                console.error("Could not detect language. Setting english as default.");
                _this.languageIndex = 0;
                _this.translateStrings();
            });
        };
        ShellApp.prototype.translateStrings = function () {
            this.loadingText.textContent = this.strings[0][this.languageIndex];
            this.retryButton.textContent = this.strings[1][this.languageIndex];
            this.failedToConnectText.textContent = this.strings[2][this.languageIndex];
            this.retryText = this.strings[3][this.languageIndex];
            this.statusWord = this.strings[4][this.languageIndex];
            this.mainBody.style.display = "block";
        };
        //https://stackoverflow.com/questions/6121203/how-to-do-fade-in-and-fade-out-with-javascript-and-css
        ShellApp.prototype.unfade = function (element, time) {
            var op = 0.1; // initial opacity
            element.style.display = 'block';
            var timer = setInterval(function () {
                if (op >= 1) {
                    clearInterval(timer);
                }
                element.style.opacity = op;
                element.style.filter = 'alpha(opacity=' + op * 100 + ")";
                op += op * 0.1;
            }, time);
        };
        ShellApp.prototype.displayFrame = function () {
            this.loadingDom.style.display = "none";
            this.frame.style.width = "100vw";
            this.frame.style.height = "100vh";
            this.frame.frameBorder = "0";
            this.frame.scrolling = "no";
            if (this.firstLoad) {
                this.frame.style.opacity = "0";
                this.unfade(this.frame, 10);
                this.firstLoad = false;
            }
            else {
                this.frame.style.opacity = "1";
            }
        };
        ShellApp.prototype.frameOnload = function () {
            // this.displayFrame();
        };
        return ShellApp;
    }());
    exports.__esModule = true;
    exports["default"] = ShellApp;
});
define("app/drive/www/driveApp", ["require", "exports", "src/shellApp"], function (require, exports, shellApp_1) {
    "use strict";
    var numberOfClicks = 0;
    var DriveApp = (function (_super) {
        __extends(DriveApp, _super);
        function DriveApp() {
            _super.call(this);
            this.whitelabel = "";
            this.defaultServer = "my.geotab.com";
            this.htmlPage = "/drive/" + (!this.isDevMode ? "default.html" : "default-dev.html");
            this.resetTargetServer();
        }
        DriveApp.prototype.receiveMessage = function (event) {
            _super.prototype.receiveMessage.call(this, event);
            switch (event.data.type) {
                // Happens after deviceready is configured in Drive app
                case "drive:listening":
                    if (this.startupBatteryEventData) {
                        console.log("SHELL STARTUP batterystatus" + ": " + JSON.stringify(this.startupBatteryEventData));
                        this.frame.contentWindow.dispatchEvent(new CustomEvent("batterystatus", { detail: this.startupBatteryEventData }));
                    }
                    break;
                case "drive:last-server":
                    // Called after appcache has completed the download
                    window.localStorage.setItem("last-server", this.getServerUrl(event.data.server));
                    this.displayFrame();
                    break;
                case "drive:login-ready":
                    this.displayFrame();
                    break;
                case "drive:appcacheerror":
                    this.frame.style.display = "none";
                    this.frame.src = "about:blank";
                    this.errorMessage.textContent = event.data.message || "";
                    this.shellDom.style.display = "block";
                    window.Raygun.send(new Error("Shell: Failed to load AppCache (" + (event.data.message || "") + ")"));
                    break;
                case "drive:settempstorage":
                    this.tempStorage.setTempStorage(event.data.key, event.data.value);
                    break;
                default:
                    return;
            }
        };
        DriveApp.prototype.frameOnload = function () {
            if (this.isDisableSsl) {
                this.frame.contentWindow.DRIVE_DEBUG.DISABLE_SSL = true;
            }
            // Pass over Cordova plugin window references
            this.frame.contentWindow.androidCheckmate = window.androidCheckmate;
            this.frame.contentWindow.cordova = window.cordova;
            this.frame.contentWindow.navigator.app = window.navigator.app;
            this.frame.contentWindow.navigator.battery = window.navigator.battery;
            this.frame.contentWindow.navigator.camera = window.navigator.camera;
            this.frame.contentWindow.navigator.cancelVibration = window.navigator.cancelVibration;
            this.frame.contentWindow.navigator.compass = window.navigator.compass;
            this.frame.contentWindow.navigator.contacts = window.navigator.contacts;
            this.frame.contentWindow.navigator.device = window.navigator.device;
            this.frame.contentWindow.navigator.globalization = window.navigator.globalization;
            this.frame.contentWindow.navigator.network = window.navigator.network;
            this.frame.contentWindow.navigator.notification = window.navigator.notification;
            this.frame.contentWindow.navigator.vibrate = window.navigator.vibrate;
            this.frame.contentWindow.navigator.vibrateWithPattern = window.navigator.vibrateWithPattern;
            this.frame.contentWindow.device = window.device;
            this.frame.contentWindow.battery = window.battery;
            this.frame.contentWindow.StatusBar = window.StatusBar;
            this.frame.contentWindow.plugin = window.plugin;
            this.frame.contentWindow.plugins = window.plugins;
            this.frame.contentWindow.appAvailability = window.appAvailability;
            this.frame.contentWindow.resolveLocalFileSystemURL = window.resolveLocalFileSystemURL;
            this.frame.contentWindow.requestFileSystem = window.requestFileSystem;
            this.frame.contentWindow.FileTransfer = window.FileTransfer;
            this.frame.contentWindow.FileTransferError = window.FileTransferError;
            this.frame.contentWindow.FileUploadOptions = window.FileUploadOptions;
            this.frame.contentWindow.FileUploadResult = window.FileUploadResult;
            this.frame.contentWindow.FileList = window.FileList;
            this.frame.contentWindow.FileReader = window.FileReader;
            this.frame.contentWindow.FileSystem = window.FileSystem;
            this.frame.contentWindow.GlobalizationError = window.GlobalizationError;
            this.frame.contentWindow.Media = window.Media;
            this.frame.contentWindow.Capture = window.Capture;
            this.frame.contentWindow.CaptureAudioOptions = window.CaptureAudioOptions;
            this.frame.contentWindow.CaptureImageOptions = window.CaptureImageOptions;
            this.frame.contentWindow.CaptureVideoOptions = window.CaptureVideoOptions;
            this.frame.contentWindow.CaptureCallback = window.CaptureCallback;
            this.frame.contentWindow.CaptureErrorCB = window.CaptureErrorCB;
            this.frame.contentWindow.ConfigurationData = window.ConfigurationData;
            this.frame.contentWindow.MediaFile = window.MediaFile;
            this.frame.contentWindow.MediaFileData = window.MediaFileData;
            //change the defualt behavior of the app
            this.frame.contentWindow.open = window.cordova.InAppBrowser.open;
            this.frame.contentWindow.getTempStorage = this.tempStorage.getTempStorage;
            this.frame.contentWindow.cordova.speechSynthesis = window.speechSynthesis;
            this.frame.contentWindow.cordova.SpeechSynthesisUtterance = window.SpeechSynthesisUtterance;
            this.frame.contentWindow.cordova.SpeechSynthesisEvent = window.SpeechSynthesisEvent;
            this.frame.contentWindow.cordova.SpeechSynthesisVoice = window.SpeechSynthesisVoice;
            this.frame.contentWindow.cordova.SpeechSynthesisVoiceList = window.SpeechSynthesisVoiceList;
            // Whitelabel container
            this.frame.contentWindow.whitelabel = this.whitelabel;
        };
        return DriveApp;
    }(shellApp_1["default"]));
    exports.__esModule = true;
    exports["default"] = DriveApp;
});
define("app/tmobile-drive/www/syncUpFleetHos", ["require", "exports", "app/drive/www/driveApp"], function (require, exports, driveApp_1) {
    "use strict";
    var SyncUpFleetHos = (function (_super) {
        __extends(SyncUpFleetHos, _super);
        function SyncUpFleetHos() {
            _super.call(this);
            this.whitelabel = "syncupfleet";
            this.defaultServer = "sf.mysyncupfleet.com";
            this.htmlPage = "/drive/" + (!this.isDevMode ? "default.html" : "default-dev.html");
            this.resetTargetServer();
        }
        return SyncUpFleetHos;
    }(driveApp_1["default"]));
    exports.__esModule = true;
    exports["default"] = SyncUpFleetHos;
});
define("app/tmobile-drive/www/index", ["require", "exports", "app/tmobile-drive/www/syncUpFleetHos"], function (require, exports, syncUpFleetHos_1) {
    "use strict";
    var app = new syncUpFleetHos_1["default"]();
    app.initialize();
});
